#include <iostream>
#include <sstream>
#include <string>
#include <math.h>
using namespace std;

class point {
private:  
   float x, y;
public:
   point( float x, float y ) {                   // конструктор
      this->x = x; this->y = y;
   }
   point( const point& p ) {                     // копирование
      x = p.x; y = p.y;
   }
   void operator =( const point& p ) {           // присваивание
      x = p.x; y = p.y;
   }
   operator string() {                           // преобразование в строку
      ostringstream o;
      o << '[' << x << ',' << y << ']';
      return o.str();
   }
   bool operator ==( const point& p ) {          // равенство
      return x == p.x && y == p.y;
   }
   bool operator !=( const point& p ) {          // неравенство
      return x != p.x || y != p.y;
   }
   float operator -( const point& p );           // расстояние 2-х 3D
   friend ostream& operator << ( ostream&, point& );
};                                               // конец класса для 2D точек

float point::operator -( const point& p ) {
   float dx = ( x - p.x ), dy = ( y - p.y );
   return sqrtf( dx * dx + dy * dy );
};

inline ostream& operator <<( ostream& o, point& p ) { // вывод 3D
   return o << (string)p;
};

int main( int argc, char **argv ) {
   float x, y;
   while( 1 ) {
      cout << "введите координаты X и Y точки (вещественные): ";
      cin >> x >> y;
      point p( x, y );
      cout << "координаты точки: " << p << endl
           << "расстояние от начала = " << p - point( 0, 0 ) << endl;
   }
   return 0;
}
