#include <iostream>
#include <sstream>
#include <string>
#include <complex>
#include <cmath>
using namespace std;

class point : protected complex<double> {       // наследуемый класс от комплексного
public:  
   point( void ) {                              // конструктор
      *(complex<double>*)this = complex<double>( 0.0, 0.0 );
   }
   point( double x, double y ) {                // конструктор 
      *(complex<double>*)this = complex<double>( x, y );
   }
   point( const point& p ) {                    // копирование
      *(complex<double>*)this = p;
   }
   void operator =( const point& p ) {           // присваивание
      *(complex<double>*)this = p;
   }
   point operator +( const point& p ) {          // смещение
      complex<double> c = *(complex<double>*)this +
                          (complex<double>)p;
      return point( c.real(), c.imag() );
   } 
   point operator +=( const point& p ) {         // смещение
      *(complex<double>*)this += (complex<double>)p;
      return *this;
   }
   operator string() {                           // преобразование в строку
      ostringstream o;
      o << '[' << real() << ',' << imag() << ']';
      return o.str();
   } 
   bool operator ==( const point& p ) {          // равенство
      return *(complex<double>*)this == (complex<double>)p;
   }
   bool operator !=( const point& p ) {          // неравенство
      return *this != p;
   } 
   friend ostream& operator << ( ostream&, point& ); 
   float operator -( const point& p );           // расстояние 2-х 2D 
};                                               // конец класса для 2D точек

inline ostream& operator <<( ostream& o, point& p ) {
   return o << "[" <<  p.real() << "," << p.imag() << "]";
};

float point::operator -( const point& p ) {
   float dx = ( real() - p.real() ), dy = ( imag() - p.imag() );
   return sqrt( dx * dx + dy * dy );
};

int main( int argc, char **argv ) {
   float x, y;
   while( 1 ) {
      cout << "введите координаты X и Y точки (вещественные): ";
      cin >> x >> y;
      point p( x, y );
      cout << "координаты точки: " << p << endl
           << "расстояние от начала = " << p - point( 0, 0 ) << endl; 
   }
   return 0;
}
