#include <iostream>
#include <sstream>
#include <string>
#include <math.h>
using namespace std;

typedef struct {
   float X, Y;
} point_t;                        // тип 2D точки

string str_point( point_t& p ) {  // формат отображения 2D
   ostringstream out;
   out << '[' << p.X << ',' << p.Y << ']';
   return out.str();
}

float dist ( const point_t& p1, const point_t& p2 ) {
   float dx = ( p1.X - p2.X ), dy = ( p1.Y - p2.Y );
   return sqrtf( dx * dx + dy * dy );
}

//---------------------------------------------------------------

typedef struct triangle {          // класс треугольник производный от point_t
   static const int NODES = 3;     // число вершин
   point_t pt[ NODES ];            // координаты вершин
} triangle_t;

int main( int argc, char **argv ) {
   float x, y;
   while( 1 ) {
      triangle_t tr;
      cout << "вводите координаты X и Y вершин: " << endl;
      for( int i = 0; i < triangle_t::NODES; i++ ) {
         cout << "вершина №" << i + 1 << " : ";
         cin >> x >> y;
         point_t p = { x, y };
         tr.pt[ i ] = p;
      }
      float per = 0.0;
      cout << "треугольник: ";
      for( int i = 0; i < triangle_t::NODES; i++ ) {
         cout << str_point( tr.pt[ i ] ) << " ";
         per += i == 0 ?  dist( tr.pt[ i ], tr.pt[ triangle_t::NODES - 1 ]  ) :
                          dist( tr.pt[ i ], tr.pt[ i -1 ] );  
      }
      cout << endl;
      cout << "периметр треугольника = " << per << endl;
   }
   return 0;
}
