#include <iostream>
#include <sstream>
#include <string>
#include <math.h>
using namespace std;

typedef struct {
   static const short ndim = 3;   // размерность
   float coord[ ndim ];
} point_t;                        // тип 3D точки

string str_point( point_t& p ) {  // формат отображения 2D
   ostringstream out;
   out << '[';
   for( int i = 0; i < point_t::ndim; i++ )
      out  << p.coord[ i ] << ( i != point_t::ndim - 1 ? ':' : ']' );
   return out.str();
}

float dist ( const point_t& p1, const point_t& p2 ) {
   float res = 0.0;
   for( int i = 0; i < point_t::ndim; i++ ) 
      res += ( p1.coord[ i ] - p2.coord[ i ] ) *
             ( p1.coord[ i ] - p2.coord[ i ] );
   return sqrtf( res );
}

int main( int argc, char **argv ) {
   float x, y, z;
   while( 1 ) {
      cout << "введите 3 координаты X,Y,Z точки (вещественные): ";
      cin >> x >> y >> z;
      point_t p = { x, y, z };
      cout << "координаты точки: " << str_point( p ) << endl;
      point_t p0 = { 0, 0, 0 };
      cout << "расстояние от начала = " << dist( p, p0 ) << endl;
   }
   return 0;
}
