#include <iostream>
#include <sstream>
#include <string>
#include <math.h>
using namespace std;

class point {
protected:
   static const short ndim = 3;                  // размерность
   float coord[ ndim ];
public:
   point( float x, float y, float z ) {          // конструктор
      coord[ 0 ] = x; coord[ 1 ] = y; coord[ 2 ] = z;
   }
   point( const point& p ) {                     // копирование
      for( int i = 0; i < point::ndim; i++ )
         coord[ i ] = p.coord[ i ];
   }
   operator string() {
      ostringstream o;
      o << '[';
      for( int i = 0; i < point::ndim; i++ )
         o << coord[ i ] << ( i != point::ndim - 1 ? ':' : ']' );
      return o.str();
   }
   bool operator ==( const point& p ) {          // равенство
      for( int i = 0; i < point::ndim; i++ )
         if( coord[ i ] != p.coord[ i ] ) return false;
      return true; 
   }
   bool operator !=( const point& p ) {          // неравенство
      return !( *this == p );
   }
   float operator -( const point& p );           // расстояние 2-х 3D
   friend ostream& operator << ( ostream&, point& );
};                                               // конец класса объектов 3D точек

float point::operator -( const point& p ) {
   float res = 0.0;
   for( int i = 0; i < point::ndim; i++ ) 
      res += ( coord[ i ] - p.coord[ i ] ) *
             ( coord[ i ] - p.coord[ i ] );
   return sqrtf( res );
};

inline ostream& operator <<( ostream& o, point& p ) { // вывод 3D
   return o << (string)p;
};

int main( int argc, char **argv ) {
   float x, y, z;
   while( 1 ) {
      cout << "введите 3 координаты X,Y,Z точки (вещественные): ";
      cin >> x >> y >> z;
      point p( x, y, z );
      cout << "координаты точки: " << p << endl;
      cout << "расстояние от начала = " 
           << p - point( 0, 0, 0 ) << endl;
   }
   return 0;
}
